//----------------------------------------------------------------------
// DelphiTwain  download https://github.com/tiagoefmoraes/delphi-twain
//----------------------------------------------------------------------

unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  System.UITypes, Graphics, Vcl.Controls, Vcl.Forms,
  Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, Vcl.ExtDlgs,
  Vcl.Buttons, Vcl.ComCtrls, DelphiTwain, DelphiTwain_Vcl, Vcl.Imaging.pngimage;

type
  TForm1 = class(TForm)
    OpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Edit1: TEdit;
    Label1: TLabel;
    DownBtn: TButton;
    UpBtn: TButton;
    MakeTiffBtn: TButton;
    AddFileBtn: TButton;
    SaveFileBtn: TButton;
    CancelBtn: TButton;
    Edit2: TEdit;
    Label2: TLabel;
    DeleteBtn: TButton;
    Edit3: TEdit;
    Label3: TLabel;
    InsertBtn: TButton;
    CheckBox1: TCheckBox;
    Image2: TImage;
    ListBox1: TListBox;
    BtnScanWithDialog: TButton;
    Image3: TImage;
    FsaveDispbtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Label4: TLabel;
    OverWriteBtn: TButton;
    procedure OpenBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DownBtnClick(Sender: TObject);
    procedure UpBtnClick(Sender: TObject);
    procedure MakeTiffBtnClick(Sender: TObject);
    procedure SaveFileBtnClick(Sender: TObject);
    procedure AddFileBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure InsertBtnClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BtnScanWithDialogClick(Sender: TObject);
    procedure FsaveDispbtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure OverWriteBtnClick(Sender: TObject);
  private
    Twain: TDelphiTwain;
    function TWainCreat: Boolean;
    procedure TwainTwainAcquire(Sender: TObject; const Index: Integer;
      Image: TBitmap; var Cancel: Boolean);
    procedure ReloadSources;
    procedure Scanerin;

    procedure PageDisp(P: integer);
    procedure FirstWork(Fname: string);
    procedure AddWork(FaddS: TMemoryStream; LTiif: boolean);
    procedure DeletePage(Page: integer);
    procedure insertimge(InsS : TMemoryStream; ipage: integer; LTiff: boolean);
    procedure FirstStream(FrtS : TMemoryStream);
    procedure FirstEncode;

    function MyMessageBox(Const Msg: String): integer;
    function StartMessageBox(Const Msg: String): integer;
    procedure DispImge(P: integer);
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  LGPImage        : TGPImage;
  LPageCount      : Integer = 0;
  LPageDimensions : TGPSizeF;
  LPageGuid       : TGUID;
  FPage           : Integer = -1;

  LEncoderParams      : TEncoderParameters;
  LEncoderParamValue  : TEncoderValue;
  LclsidTIFF          : TGUID;
  LGPImageTIFF      : TGPImage;
  Fname             : string;
  Exstr             : string;
  LFirstTiff        : boolean;
  FFileoutStream    : TMemoryStream;
  FFileinpStream    : TMemoryStream;

  LGPImageDisp      : TGPImage;
  InsertF           : Boolean;
  InsertP           : Integer;
  ChangF            : Boolean;
  OverWF            : Boolean;
//-------------------------------------------
// X^[gIbZ[W{bNX
//-------------------------------------------
function TForm1.StartMessageBox(Const Msg: String): integer;
var
  Dlg:TForm;
begin
   Dlg:=CreateMessageDialog(Msg, mtError, [mbYes, mbNo, mbCancel]);
   with Dlg do
   try
     Caption := 'ҏW@̑I';
     TImage(Components[0]).Picture.Assign(Image3.Picture);
//     TImage(Components[0]).Picture.LoadFromFile(Filename);
     TButton(Components[2]).Caption := 'VK';             // ret 6
     TButton(Components[3]).Caption := 'TiFFt@C';     // ret 7
     TButton(Components[4]).Caption := '';         // ret 2

     result:= ShowModal;                                   // N[Y 2
   finally
     Free;
   end;
end;

//-------------------------------------------
// \[XIbZ[W{bNX
//-------------------------------------------
function TForm1.MyMessageBox(Const Msg: String): integer;
var
  Dlg:TForm;
begin
   Dlg:=CreateMessageDialog(Msg, mtError, [mbYes, mbNo, mbCancel]);
   with Dlg do
   try
     Caption := '\[X̑I';
     TImage(Components[0]).Picture.Assign(Image2.Picture);
//     TImage(Components[0]).Picture.LoadFromFile(Filename);
     TButton(Components[2]).Caption := 't@C';           // ret 6
     TButton(Components[3]).Caption := 'XLi[';         // ret 7
     TButton(Components[4]).Caption := '';           // ret 2

     result:= ShowModal;                                     // N[Y 2
   finally
     Free;
   end;
end;

//--------------------------------------
// TwainfoCẌꗗ\
//--------------------------------------
procedure TForm1.ReloadSources;
var
  I: Integer;
begin
  ListBox1.Items.Clear;
  for I := 0 to Twain.SourceCount - 1 do
    ListBox1.Items.Add(Twain.Source[I].ProductName);

  if ListBox1.Items.Count > 0 then
    ListBox1.ItemIndex := 0;
end;

//------------------------------------
// TwainfoCX̎擾
//------------------------------------
function TForm1.TWainCreat: Boolean;
begin
  if Twain <> nil then FreeAndNil(Twain);
  Twain := TDelphiTwain.Create;
  // Twain摜擾荞ݐݒ
  Twain.OnTwainAcquire := TwainTwainAcquire;
  // TwainfoCXCuC̎擾
  if Twain.LoadLibrary then
  begin
    //Load source manager
    Twain.SourceManagerLoaded := TRUE;

    ReloadSources;
    result := True;
  end else begin
    ShowMessage('Twain is not installed.');
    result := False;
  end;
end;

//---------------------------------
// Twain摜̎擾荞ݏ
// Cancel := True Ŏ擾I
// Image:   擾摜
// Index:   擾摜Index
// Cancel:  摜擾ł؂tO true őł؂
//---------------------------------
procedure TForm1.TwainTwainAcquire(Sender: TObject; const Index: Integer;
  Image: TBitmap; var Cancel: Boolean);
var
  FBitmapStream     : TMemoryStream;
begin
  FBitmapStream := TMemoryStream.Create;
  try
    Image.SaveToStream(FBitmapStream);
    if not InsertF then begin
      if not LFirstTiff then begin
        FirstStream(FBitmapStream);               // ŏ̃y[W쐬
        SaveFileBtn.Enabled := True;
        LFirstTiff := True;                       // ŏ̃y[W쐬tOZbg
      end
      else
        AddWork(FBitmapStream, False);            // y[W̒ǉ
    end
    else
      insertimge(FBitmapStream, InsertP, False);  // y[W̑}
  finally
    FBitmapStream.Free;
  end;
  Cancel := True;                                 // Only want one image

  if LPageCount > 0 then begin
    insertbtn.Enabled := True;
    deleteBtn.Enabled := True
  end
  else begin
    insertbtn.Enabled := False;
    deleteBtn.Enabled := False;
  end;
end;

//------------------------------
// TwainfoCXł̉摜擾Jn
//------------------------------
procedure TForm1.Scanerin;
begin
  if not TWainCreat then begin
    BtnScanWithDialog.Enabled := False;
    exit;
  end;
  BtnScanWithDialog.Enabled := True;
end;

//-------------------------------------
// w肳ꂽTwinfoCXŉ摜̎擾
//-------------------------------------
procedure TForm1.BtnScanWithDialogClick(Sender: TObject);
begin
  Twain.SelectedSourceIndex := ListBox1.ItemIndex;
  if Assigned(Twain.SelectedSource) then begin
    // Load source, select transference method and enable (display interface)}
    Twain.SelectedSource.Loaded := True;
    Twain.SelectedSource.ShowUI := True;  // display interface
    Twain.SelectedSource.Enabled := True;
  end;
  BtnScanWithDialog.Enabled := False;
end;

//--------------------------------------------------
// Tifft@CҏW̕\Tifft@Cۑ
//--------------------------------------------------
procedure TForm1.FsaveDispbtnClick(Sender: TObject);
var
  Oname: string;
begin
  if LPageCount < 1 then exit;
  SavePictureDialog1.Filter := 'ׂ (*.tif;*.tiff)|*.tif;*.tiff'
                             + '|TIFF 摜 (*.tif) |*.tif'
                             + '|TIFF 摜 (*.tiff)|*.tiff';
  if not SavePictureDialog1.Execute then exit;
  Oname := SavePictureDialog1.FileName;
  Exstr := LowerCase(ExtractFileExt(Oname));
  if (Exstr = '.tif') or (Exstr = '.tiff') then else
    Oname := ChangeFileExt(Oname,'.tif');
  if FileExists(Oname) then         // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Oname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;
  LEncoderParamValue := EncoderValueFrameDimensionPage;
  LGPImageDisp.Save(Oname, LclsidTIFF, @LEncoderParams)
end;

//----------------------------------
// 摜ǉ폜}̕\
// P Ō̃y[W\
//----------------------------------
procedure TForm1.DispImge(P: integer);
begin
  // ʕ\ݒ
  // FreeAndNilgpȂ Nil ɐݒ肳Ȃꍇ܂
  if LGPImageDisp <> nil then FreeAndNil(LGPImageDisp);
  // o͗p[Xg[Ƃ̊֘At
  LGPImageDisp := TGPImage.Create(TStreamAdapter.Create(FFileoutStream, soReference));
  LPageGuid := FrameDimensionPage;
  LPageCount := LGPImageDisp.GetFrameCount(LPageGuid);
  // \y[WŏIy[WڂɃZbg
  if P < 0 then
    FPage := LPageCount - 1
  else
    FPage := P;
  // y[W\
  if LPageCount = P then Fpage := LPageCount - 1;
  Edit1.Text := intTostr(Fpage + 1) + ' / ' + intTostr(LPageCount);
  Edit2.Text := intTostr(Fpage + 1);
  Edit3.Text := intTostr(Fpage + 1);
  PageDisp(FPage);
end;

//--------------------
// GR[hw
//--------------------
procedure TForm1.FirstEncode;
begin
  MakeTiffBtn.Enabled := False;
  // łTIFFւ̃GR[hw
  LEncoderParams.Count := 1;
  LEncoderParams.Parameter[0].Guid           := EncoderSaveFlag;
  LEncoderParams.Parameter[0].Type_          := EncoderParameterValueTypeLong;
  LEncoderParams.Parameter[0].NumberOfValues := 1;
  LEncoderParams.Parameter[0].Value          := @LEncoderParamValue;
  // TIFFGUID擾
  GetEncoderClsid('image/tiff', LclsidTIFF);
end;

//----------------------------------------------------------
// ŏ̉摜Xg[Tiff`Ń[Xg[ɕۑ
//----------------------------------------------------------
procedure TForm1.FirstStream(FrtS : TMemoryStream);
begin
  // GR[hw
  FirstEncode;
  // o͗p[Xg[
  if FFileoutStream <> nil then FreeAndNil(FFileoutStream);
  FFileoutStream := TMemoryStream.Create;
  if LGPImage <> nil then FreeAndNil(LGPImage);
  // LGPImageɓ̓t@CXg[֘At
  LGPImage := TGPImage.Create(TStreamAdapter.Create(FrtS, soReference));
  // p[^}`y[Wɐݒ
  LEncoderParamValue := EncoderValueMultiFrame;
  // Py[Wڂo͗p[Xg[ɕۑ o͐ o͌` GR[hp[^[ ̎w
  LGPImage.Save(TStreamAdapter.Create(FFileoutStream, soReference), LclsidTIFF, @LEncoderParams);
  // ŏ̃y[W摜\
  DispImge(0);
  ChangF := true;
  if OverWF then OverWritebtn.Enabled := True;
end;

//----------------------------------------------------------
// ŏ̉摜t@CTiff`Ń[Xg[ɕۑ
// ǂݍݗpt@CXg[͏ȗ\ł
//----------------------------------------------------------
procedure TForm1.FirstWork(Fname: string);
var
  i : integer;
begin
  // FFileinpStreamɓ̓t@C֘AtĂ
  if FFileinpStream <> nil then FreeAndNil(FFileinpStream);
  FFileinpStream  := TMemoryStream.Create;
  // [Xg[Ƀt@Cǂݍ
  FFileinpStream.LoadFromFile(Fname);
  // GR[hw
  FirstEncode;
  // o͗p[Xg[
  if FFileoutStream <> nil then FreeAndNil(FFileoutStream);
  FFileoutStream := TMemoryStream.Create;
  // LGPImageɓ͉摜֘AtĂ
  // FreeAndNilgpȂ Nil ɐݒ肳Ȃꍇ܂
  if LGPImage <> nil then FreeAndNil(LGPImage);
  // LGPImageɓ̓t@CXg[֘At
  LGPImage := TGPImage.Create(TStreamAdapter.Create(FFileinpStream, soReference));
  // ̓t@C̊gq̎o
  Exstr := LowerCase(ExtractFileExt(Fname));
  LPageCount := 1;
  // Tiff 
  if (Exstr = '.tif') or (Exstr = '.tiff') then begin
    // Tiff̃y[Wݒ擾p
    LPageGuid := FrameDimensionPage;
    // y[W擾
    LPageCount := LGPImage.GetFrameCount(LPageGuid);
    // Py[WڂANeBu
    LGPImage.SelectActiveFrame(LPageGuid, 0);
    // p[^}`y[Wɐݒ
    LEncoderParamValue := EncoderValueMultiFrame;
    // Py[Wڂo͗p[Xg[ɕۑ o͐ o͌` GR[hp[^[ ̎w
    LGPImage.Save(TStreamAdapter.Create(FFileoutStream, soReference), LclsidTIFF, @LEncoderParams);
    // y[Wǉۑ
    if LPageCount > 1 then begin
      for i := 1 to LPageCount - 1 do begin
        LGPImage.SelectActiveFrame(LPageGuid, i);
        // Iy[W̃y[WԂ̏ݐݒ  ǉy[W
        LEncoderParamValue := EncoderValueFrameDimensionPage;
        // ǉۑ o͌ GR[hp[^[ ̎w ǉ̎͏o͐̎w͕sv
        LGPImage.SaveAdd(LGPImage, @LEncoderParams);
      end;
    end;
    // ŏ̊JnTift@C㏑tOZbg
    OverWF := True;
  end
  // Tifft@CȊO
  else begin
    // p[^}`y[Wɐݒ
    LEncoderParamValue := EncoderValueMultiFrame;
    // [Xg[Tiff`Ƃĕۑ
    LGPImage.Save(TStreamAdapter.Create(FFileoutStream, soReference), LclsidTIFF, @LEncoderParams);
    ChangF := true;
  end;
  // Ō̃y[W摜\
  DispImge(LPageCount - 1);
  FsaveDispbtn.Enabled := True;
  // KvȂȂ̂ŉ
  FreeAndnil(FFileinpStream);
end;

//---------------------------------------------
// 摜Xg[̒ǉ
// Ō̃y[Wɒǉ܂}͂܂
//---------------------------------------------
procedure TForm1.AddWork(FaddS: TMemoryStream; LTiif: boolean);
var
  i : integer;
begin
  // ǂݍݗpt@C֘At
  LGPImageTIFF := TGPImage.Create(TStreamAdapter.Create(FaddS, soReference));
  // Tiff t@C
  if LTiif then begin
    try
      // Tiff̃y[Wݒ擾p
      LPageGuid := FrameDimensionPage;
      // y[W擾
      LPageCount := LGPImageTIff.GetFrameCount(LPageGuid);
      // y[Wo͗p[Xg[ɒǉۑ
      for i := 0 to LPageCount - 1 do begin
        // ANeBuy[W̐ݒ
        LGPImageTIFF.SelectActiveFrame(LPageGuid, i);
        // Iy[W̃y[WԂ̏ݐݒ ǉy[W
        LEncoderParamValue := EncoderValueFrameDimensionPage;
        // ǉۑ
        LGPImage.SaveAdd(LGPImageTIFF, @LEncoderParams);
      end;
    finally
      // LGPImageTIFF̊֘At
      LGPImageTIFF.Free;
    end;
  end
  // Tiff ȊO
  else begin
    try
      // Iy[W̃y[WԂ̏ݐݒ ǉݒ
      LEncoderParamValue := EncoderValueFrameDimensionPage;
      // ǉۑ ŏ Saveŏo͐悪ݒ肳Ă̂ŏo͕͐svł
      LGPImage.SaveAdd(LGPImageTIFF, @LEncoderParams);
    finally
      // LGPImageTIFF̊֘At
      LGPImageTIFF.Free;
    end;
  end;
  // Ō̃y[W摜\
  DispImge(-1);
  ChangF := true;
  if OverWF then OverWritebtn.Enabled := True;
end;

//-----------------------------------------
// wy[W̍폜
// Py[Ŵ͍̂폜ł܂
//-----------------------------------------
procedure TForm1.DeletePage(Page: Integer);
var
  I, P            : integer;
  FDelStream      : TMemoryStream;
begin
  // Py[WȂ珉I
  if LPageCount = 1 then begin
    LFirstTiff := False;
    LPageCount := 0;
    DeleteBtn.Enabled := False;
    SaveFileBtn.Enabled := False;
    FsaveDispbtn.Enabled := False;
    OverWritebtn.Enabled := False;
    Image1.Canvas.Brush.Color := clBtnface;
    Image1.Canvas.FillRect(Image1.Canvas.ClipRect);
    Edit1.Text := '';
    Edit2.Text := '';
    Edit3.Text := '';
    ChangF := False;
    exit;
  end;
  // 2y[Wȏ゠wy[W폜
  FDelStream := TMemoryStream.Create;
  FDelStream.SetSize(0);
  // FDelStream FFileoutStreamRs[
  FDelStream.CopyFrom(FFileoutStream, 0);
  // FFileoutStreamNA
  FFileoutStream.Clear;
  if LGPImage <> nil then FreeAndNil(LGPImage);
  // LGPImageɓ̓t@CXg[֘At
  LGPImage := TGPImage.Create(TStreamAdapter.Create(FDelStream, soReference));
  try
    LPageGuid := FrameDimensionPage;
    // y[W擾
    LPageCount := LGPImage.GetFrameCount(LPageGuid);
    // Py[WڂANeBu
    if Page = 1 then P := 1 else P := 0;
    LGPImage.SelectActiveFrame(LPageGuid, P);
    // p[^}`y[Wɐݒ
    LEncoderParamValue := EncoderValueMultiFrame;
    // Py[Wڂo͗p[Xg[ɕۑ o͐ o͌` GR[hp[^[ ̎w
    LGPImage.Save(TStreamAdapter.Create(FFileoutStream, soReference), LclsidTIFF, @LEncoderParams);
    // Iy[W̃y[WԂ̏ݐݒ ǉݒ
    LEncoderParamValue := EncoderValueFrameDimensionPage;
    // y[Wǉۑ
    if LPageCount > 1 then begin
      for I := P + 1 to LPageCount - 1 do begin
        // wy[WȊOǉۑ
        if (I + 1) <> Page then begin
          LGPImage.SelectActiveFrame(LPageGuid, I);
          // ǉۑ o͌ GR[hp[^[ ̎w ǉ̎͏o͐̎w͕sv
          LGPImage.SaveAdd(LGPImage, @LEncoderParams);
        end;
      end;
    end;
  finally
    FDelStream.Free;
  end;
  // 폜̃y[W摜\
  DispImge(Page - 1);
  ChangF := true;
  if OverWF then OverWritebtn.Enabled := True;
end;

//--------------------------------------------------
// wy[Wɉ摜Xg[}
//--------------------------------------------------
procedure TForm1.insertimge(InsS : TMemoryStream; ipage: integer; LTiff: boolean);
var
  I, J            : integer;
  FAddStream      : TMemoryStream;
  Jpagecount      : integer;
begin
  // FADDStream[Xg[
  FAddStream := TMemoryStream.Create;
  FAddStream.SetSize(0);
  // FADDStream FFileoutStreamRs[
  FAddStream.CopyFrom(FFileoutStream, 0);
  // o͗p[Xg[NA
  FFileoutStream.Position := 0;
  FFileoutStream.SetSize(0);
  if LGPImage <> nil then FreeAndNil(LGPImage);
  // }y[W1y[Wڂ
  if ipage = 1 then begin
    LGPImage := TGPImage.Create(TStreamAdapter.Create(InsS, soReference));
    // Tiff t@C
    if LTiff then begin
      // Tiff̃y[Wݒ擾p
      LPageGuid := FrameDimensionPage;
      // y[W擾
      Jpagecount := LGPImage.GetFrameCount(LPageGuid);
      // Py[WڂANeBu
      LGPImage.SelectActiveFrame(LPageGuid, 0);
      // p[^}`y[Wɐݒ
      LEncoderParamValue := EncoderValueMultiFrame;
      // Py[Wڂo͗p[Xg[ɕۑ o͐ o͌` GR[hp[^[ ̎w
      LGPImage.Save(TStreamAdapter.Create(FFileoutStream, soReference), LclsidTIFF, @LEncoderParams);
      // y[Wǉۑ
      // Iy[W̃y[WԂ̏ݐݒ ǉy[W
      LEncoderParamValue := EncoderValueFrameDimensionPage;
      if Jpagecount > 1 then begin
        for I := 1 to Jpagecount - 1 do begin
          LGPImage.SelectActiveFrame(LPageGuid, I);
          // ǉۑ o͌ GR[hp[^[ ̎w ǉ̎͏o͐̎w͕sv
          LGPImage.SaveAdd(LGPImage, @LEncoderParams);
        end;
      end;
    end
    // Tifft@CȊO
    else begin
      // p[^}`y[Wɐݒ
      LEncoderParamValue := EncoderValueMultiFrame;
      // [Xg[Tiff`Ƃĕۑ
      LGPImage.Save(TStreamAdapter.Create(FFileoutStream, soReference), LclsidTIFF, @LEncoderParams);
    end;
    // LGPImageTIFFƃt@C̊֘At
    LGPImageTIFF := TGPImage.Create(TStreamAdapter.Create(FAddStream, soReference));
    try
      LPageGuid := FrameDimensionPage;
      // y[W擾
      LPageCount := LGPImageTIFF.GetFrameCount(LPageGuid);
      // Iy[W̃y[WԂ̏ݐݒ  ǉy[W
      LEncoderParamValue := EncoderValueFrameDimensionPage;
      // y[Wo͗p[Xg[ɒǉۑ
      for I := 0 to LPageCount - 1 do begin
        // ANeBuy[W̐ݒ
        LGPImageTIFF.SelectActiveFrame(LPageGuid, I);
        // ǉۑ
        LGPImage.SaveAdd(LGPImageTIFF, @LEncoderParams);
      end;
    finally
      // LGPImageTIFF̊֘At
      LGPImageTIFF.Free;
      FAddStream.Free;
    end;
  end
  // Py[Wڈȍ~
  else begin
    // LGPImageɓ̓t@CXg[֘At
    LGPImage := TGPImage.Create(TStreamAdapter.Create(FAddStream, soReference));
    LGPImageTIff := TGPImage.Create(TStreamAdapter.Create(InsS, soReference));
    try
      // Tiff̃y[Wݒ擾p
      LPageGuid := FrameDimensionPage;
      // y[W擾
      LPageCount := LGPImage.GetFrameCount(LPageGuid);
      // Py[WڂANeBu
      LGPImage.SelectActiveFrame(LPageGuid, 0);
      // p[^}`y[Wɐݒ
      LEncoderParamValue := EncoderValueMultiFrame;
      // Py[Wڂo͗p[Xg[ɕۑ o͐ o͌` GR[hp[^[ ̎w
      LGPImage.Save(TStreamAdapter.Create(FFileoutStream, soReference), LclsidTIFF, @LEncoderParams);
      for I := 1 to LPageCount - 1 do begin
        // Iy[W̃y[WԂ̏ݐݒ ǉy[W
        LEncoderParamValue := EncoderValueFrameDimensionPage;
        // }y[Wƈv
        if I + 1 = ipage then begin
          // Tifft@CȂ
          if LTiff then begin
            // Tiff̃y[Wݒ擾p
            LPageGuid := FrameDimensionPage;
            // y[W擾
            Jpagecount := LGPImageTIff.GetFrameCount(LPageGuid);
            for J := 0 to Jpagecount - 1 do begin
              // Iy[WANeBu
              LGPImageTIff.SelectActiveFrame(LPageGuid, J);
              // ǉۑ
              LGPImage.SaveAdd(LGPImageTIff, @LEncoderParams);
            end;
          end
          // TiffȊOȂ
          else begin
            // }ۑ
            LGPImage.SaveAdd(LGPImageTIFF, @LEncoderParams);
          end;
        end;
        // ANeBuy[W̐ݒ
        LGPImage.SelectActiveFrame(LPageGuid, I);
        // ǉۑ
        LGPImage.SaveAdd(LGPImage, @LEncoderParams);
      end;
    finally
      LGPImageTIFF.free;
      FAddStream.Free;
    end;
  end;
  // ǉy[W̉摜\
  DispImge(ipage - 1);
  ChangF := true;
  if OverWF then OverWritebtn.Enabled := True;
end;

//-------------------------------------
// Tiff t@C쐬ҏWLZ
// Ԃɖ߂܂
//-------------------------------------
procedure TForm1.CancelBtnClick(Sender: TObject);
begin
  if MessageDlg('{ɃLZ܂' +#13#10 + 'ҏWe͑SĎ܂B',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  CancelBtn.Enabled := False;
  // o͗p[Xg[
  if FFileoutStream <> nil then FreeAndNil(FFileoutStream);
  // TGPImage LGPImage
  if LGPImage <> nil then FreeAndNil(LGPImage);
  // TGPImage LGPImageDisp
  if LGPImageDisp <> nil then FreeAndNil(LGPImageDisp);
  // Twain@̉
  if Twain <> nil then FreeAndNil(Twain);
  // ͗p[Xg[
  if FFileinpStream <> nil then FreeAndNil(FFileinpStream);
  // 摜\
  Edit1.Text := '';
  Edit2.Text := '';
  Image1.Canvas.Brush.Color := clBtnFace;
  Image1.Canvas.FillRect(Image1.Canvas.ClipRect);

  AddFileBtn.Enabled := False;
  SaveFileBtn.Enabled := False;
  OpenBtn.Enabled := True;
  MakeTiffBtn.Enabled := True;
  DownBtn.Enabled := False;
  UpBtn.Enabled   := False;
  DeleteBtn.Enabled := False;
  InsertBtn.Enabled := False;
  BtnScanWithDialog.Enabled := False;
  FsaveDispbtn.Enabled := False;
  OverWritebtn.Enabled := False;

  FPage := -1;
  LPageCount := -1;
  Form1.Caption := 'MakeTiff';
  ChangF := False;
end;

//--------------------------------------------------------------------------
const

  LFilter =  'ׂ (*.gif;*.jpg;*.jpeg;*.png;*.bmp;*.tif;*.tiff;*.ico)|*.gif;*.jpg;*.jpeg;*.png;*.bmp;*.tif;*.tiff;*.ico'
           + '|GIF 摜 (*.gif)|*.gif'
           + '|JPEG C[Wt@C (*.jpg)|*.jpg'
           + '|JPEG C[Wt@C (*.jpeg)|*.jpeg'
           + '|Portable Network Graphics (*.png)|*.png'
           + '|rbg}bv (*.bmp)|*.bmp'
           + '|TIFF 摜 (*.tif)|*.tif'
           + '|TIFF 摜 (*.tiff)|*.tiff'
           + '|ACR (*.ico)|*.ico';

//---------------------------------------------------
// V}`Tifft@C̍쐬
// Tiff t@Cw肷Ƃ̃t@C̃y[WҏW
//---------------------------------------------------
procedure TForm1.MakeTiffBtnClick(Sender: TObject);
var
  ST : integer;
begin
  Fname := '';
  // ŏTifftO
  LFirstTiff := False;
  ST := StartMessageBox('TiffҏW̑I');   // Tiff摜t@CVKI
  if ST = 2 then exit;                       // LZȂI
  if ST = 7 then begin                       // Tifft@C
    OpenPictureDialog1.Filter := 'ׂ (*.tif;*.tiff)|*.tif;*.tiff'
                               + '|TIFF 摜 (*.tif) |*.tif'
                               + '|TIFF 摜 (*.tiff)|*.tiff';
    if not OpenPictureDialog1.Execute then exit;      // LZȂI
    Fname := OpenPictureDialog1.FileName;
    Exstr := LowerCase(ExtractFileExt(Fname));
    if (Exstr = '.tif') or (Exstr = '.tiff') then     // Tifft@CmF
      // ɂTifft@CȂŏTifftOZbg
      if FileExists(Fname) then LFirstTiff := True;


    if LFirstTiff then begin
      FirstWork(Fname);                       // ҏWJn
      SaveFileBtn.Enabled := True;
      Form1.Caption := 'MakeTiff  ' + Fname;
    end
    else exit;                                // TiffȊÕt@CI
  end;
  if ST = 6 then begin                        // VKȂ
    Form1.Caption := 'MakeTiff  VK';
    LPageCount := 0;
  end;
  MakeTiffBtn.Enabled := False;
  AddFileBtn.Enabled := True;                 // ǉ{^
  OpenBtn.Enabled := False;
  Cancelbtn.Enabled := True;                  // LZ{^
  insertbtn.Enabled := True;
  if LPageCount > 0 then begin                // y[WL
    insertbtn.Enabled := True;                // }{^
    deleteBtn.Enabled := True                 // 폜{^
  end
  else begin
    insertbtn.Enabled := False;
    deleteBtn.Enabled := False;
  end;
end;

//--------------------------------------
// V}`Tifft@C̕ۑ
//--------------------------------------
procedure TForm1.SaveFileBtnClick(Sender: TObject);
var
  LSaveFile       : string;
  BackupFile      : string;
begin
  SavePictureDialog1.Filter := 'ׂ (*.tif;*.tiff)|*.tif;*.tiff'
                             + '|TIFF 摜 (*.tif) |*.tif'
                             + '|TIFF 摜 (*.tiff)|*.tiff';
  if not SavePictureDialog1.Execute then exit;
  Fname := SavePictureDialog1.FileName;
  Exstr := LowerCase(ExtractFileExt(Fname));
  if (Exstr = '.tif') or (Exstr = '.tiff') then
    LSaveFile := Fname
  else
    LSaveFile := ChangeFileExt(Fname,'.tif');
  if FileExists(LSaveFile) then         // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(LSaveFile) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit
    else begin
      BackupFile := ChangeFileExt(LSaveFile, '.bak');
      CopyFile(PWideChar(LSaveFile), PWideChar(BackupFile), false);
    end;
  // w肳ꂽt@Cŕۑ
  FFileoutStream.SaveToFile(LSaveFile);
  Form1.Caption := 'MakeTiff  ' + LSaveFile;
  ChangF := false;

//  CancelBtnClick(nil);
end;

//-------------
// ㏑ۑ
//-------------
procedure TForm1.OverWriteBtnClick(Sender: TObject);
var
  BackupFile      : string;
begin
  if FileExists(Fname) and ChangF then   // t@Cɂt@C
    if MessageDlg('{ɏ㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit
    else begin
      BackupFile := ChangeFileExt(Fname, '.bak');
      CopyFile(PWideChar(Fname), PWideChar(BackupFile), false);
    end;
  ChangF := false;
  OverWritebtn.Enabled := False;
end;

//-----------------------
// TiffɐV摜ǉ
//-----------------------
procedure TForm1.AddFileBtnClick(Sender: TObject);
var
  Ret   : integer;
  AddS  : TMemoryStream;
  LTiff : Boolean;
begin
  InsertF := False;
  BtnScanWithDialog.Enabled := False;
  Ret := MyMessageBox('t@CXLi[I');
  if Ret = 2 then exit;
  if Ret = 7 then begin
    scanerin;                  // XLi[摜擾ǉ
    exit;
  end;

  OpenPictureDialog1.Filter := LFilter;
  if not OpenPictureDialog1.Execute then exit;
  // ŏ̉摜Tiff[Xg[ɍ쐬ĂȂ쐬
  if not LFirstTiff then begin
    FirstWork(OpenPictureDialog1.FileName);
    LFirstTiff := True;
  end
  // 쐬ĂĂȂǉ
  else begin
    Exstr := LowerCase(ExtractFileExt(OpenPictureDialog1.FileName));
    LTiff := False;
    if (Exstr = '.tif') or (Exstr = '.tiff') then LTiff := True;
    AddS := TMemoryStream.Create;
    try
      AddS.LoadFromFile(OpenPictureDialog1.FileName);
      AddWork(AddS, LTiff);
    finally
      AddS.Free;
    end;
  end;
  SaveFileBtn.Enabled := True;
  if LPageCount > 0 then begin
    insertbtn.Enabled := True;
    deleteBtn.Enabled := True
  end
  else begin
    insertbtn.Enabled := False;
    deleteBtn.Enabled := False;
  end;
  ChangF := true;
  if OverWF then OverWritebtn.Enabled := True;
end;

//--------------------------
// wy[W̍폜
//--------------------------
procedure TForm1.DeleteBtnClick(Sender: TObject);
var
  check : integer;
  page  : integer;
begin
  val(Edit2.Text, Page, check);
  if (check <> 0) or (Page < 1) or (page > LPageCount) then begin
    application.MessageBox('͂ꂽlɊԈႢ܂B','',0);
    exit;
  end;
  if MessageDlg('{Ɏw肵' + intTostr(Page) + 'y[W폜܂ H',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;
  DeletePage(Page);                 // wy[W폜
  if LPageCount > 0 then begin
    insertbtn.Enabled := True;
    deleteBtn.Enabled := True
  end
  else begin
    insertbtn.Enabled := False;
    deleteBtn.Enabled := False;
  end;
end;

//------------------------------
// wy[Wɉ摜}
//------------------------------
procedure TForm1.InsertBtnClick(Sender: TObject);
var
  ipage, Ret  : integer;
  Check       : integer;
  LTiff       : Boolean;
  InsS        : TMemoryStream;
begin
  InsertF := True;
  val(Edit3.Text, iPage, check);
  if (check <> 0) or (iPage < 1) or (ipage > LPageCount) then begin
    application.MessageBox('͂ꂽlɊԈႢ܂B','',0);
    exit;
  end;
  BtnScanWithDialog.Enabled := False;
  InsertP := iPage;
  Ret := MyMessageBox('t@CXLi[I');
  if Ret = 2 then exit;
  if Ret = 7 then begin
    scanerin;         // XLi[摜擾}
    exit;
  end;
  // t@C摜}
  OpenPictureDialog1.Filter := LFilter;
  if not OpenPictureDialog1.Execute then exit;
  Exstr := LowerCase(ExtractFileExt(OpenPictureDialog1.FileName));
  LTiff := False;
  if (Exstr = '.tif') or (Exstr = '.tiff') then LTiff := True;
  InsS := TMemoryStream.Create;
  try
    InsS.LoadFromFile(OpenPictureDialog1.FileName);
    Insertimge(InsS, ipage, LTiff);
  finally
    InsS.Free;
  end;
end;

//==================================================================
//----------------------------------
// Tifft@C̉摜\
// y[Wwŕ\ 0`LPageCount - 1
//----------------------------------
procedure TForm1.PageDisp(P: integer);
var
  W, H        : Integer;
  HH, WW, WH  : double;
  LGPGraphic  : TGPGraphics;
begin
  if P < 0 then exit;
  DownBtn.Enabled := False;
  UpBtn.Enabled   := False;
  Image1.Canvas.Brush.Color := clBtnface;
//  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.FillRect(Image1.Canvas.ClipRect);
  LGPImageDisp.SelectActiveFrame(LPageGuid, P);
  LGPImageDisp.GetPhysicalDimension(LPageDimensions);
  // ey[W̉摜̃TCY
  W := Trunc(LPageDimensions.Width);
  H := Trunc(LPageDimensions.Height);
  if CheckBox1.Checked then begin
    WW := (ScrollBox1.Width  - 5) / W;
    HH := (ScrollBox1.Height - 5) / H;
    if (WW < 1) or (HH < 1) then begin
      if WW < HH then WH := WW
                 else WH := HH;
      W := Trunc(W * WH);
      H := Trunc(H * WH);
    end;
  end;
  Image1.width  := W;
  Image1.Height := H;
  Image1.Picture.Bitmap.SetSize(W, H);
  Image1.Update;
  // Image1̃TCYύXHandleς̂ŃTCYύX擾܂
  LGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);
  try
    // \ MakeRectgpƕϔ{`悪\ƂȂ܂B
    LGPGraphic.DrawImage(LGPImageDisp, MakeRect(0, 0, W, H));
//    LGPGraphic.DrawImage(LGPImageDisp, 0, 0, W, H);
    Image1.Repaint;                                        // `̍XV
  finally
    LGPGraphic.Free;
  end;
  if LPageCount > 1 then begin
    DownBtn.Enabled := True;
    UpBtn.Enabled   := True;
  end;
end;

//------------------------------------
// Tiff t@C̓ǂݍݕ\p
// \݂̂ł
//------------------------------------
procedure TForm1.OpenBtnClick(Sender: TObject);
begin
  OpenPictureDialog1.Filter := 'ׂ (*.tif;*.tiff)|*.tif;*.tiff'
                              + '|TIFF 摜 (*.tif) |*.tif'
                              + '|TIFF 摜 (*.tiff)|*.tiff';
  if not OpenPictureDialog1.Execute then exit;
  OpenBtn.Enabled := False;

  // FreeAndNilgpȂ Nil ɐݒ肳Ȃꍇ܂
  if LGPImageDisp <> nil then freeAndNil(LGPImageDisp);
  // TGPImage𐶐ĉ摜ǂݍ݁Cy[W擾
  LGPImageDisp   := TGPImage.Create(OpenPictureDialog1.FileName);
  // y[W萔Zbg y[Wݒ擾p
  LPageGuid := FrameDimensionPage;
  // y[W擾
  LPageCount := LGPImageDisp.GetFrameCount(LPageGuid);
  // \y[WPy[WڂɃZbg
  FPage := 0;
  // y[W\
  Edit1.Text := '1 / ' + intTostr(LPageCount);
  // wy[W\
  PageDisp(FPage);
  OpenBtn.Enabled := True;
  DownBtn.Enabled := True;
  UpBtn.Enabled   := True;
  insertbtn.Enabled := False;
  deleteBtn.Enabled := False;
  Form1.Caption := 'Open Tiff  ' + OpenPictureDialog1.FileName;
end;

//-------------------------------
// \y[W_E
//-------------------------------
procedure TForm1.DownBtnClick(Sender: TObject);
begin
  if Fpage > 0 then begin
    dec(Fpage);
    Edit1.Text := intTostr(Fpage + 1) + ' / ' + intTostr(LPageCount);
    Edit2.Text := intTostr(Fpage + 1);
    Edit3.Text := intTostr(Fpage + 1);
    PageDisp(Fpage);
  end;
end;

//----------------------------
// \y[WAbv
//----------------------------
procedure TForm1.UpBtnClick(Sender: TObject);
begin
  if Fpage < LPageCount - 1 then begin
    inc(Fpage);
    Edit1.Text := intTostr(Fpage + 1) + ' / ' + intTostr(LPageCount);
    Edit2.Text := intTostr(Fpage + 1);
    Edit3.Text := intTostr(Fpage + 1);
    PageDisp(Fpage);
  end;
end;

//---------------------------------------
// `FbNŃXN[o[Řg\
//---------------------------------------
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if Fpage >=0 then PageDisp(Fpage);
end;

//-------------
// ݒ
//-------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Top  := 0;
  Image1.Left := 0;
  DownBtn.Enabled := False;
  UpBtn.Enabled   := False;
  AddFileBtn.Enabled := False;
  SaveFileBtn.Enabled := False;
  Cancelbtn.Enabled := False;
  DeleteBtn.Enabled := False;
  insertbtn.Enabled := False;
  BtnScanWithDialog.Enabled := False;
  FsaveDispbtn.Enabled := False;
  OverWritebtn.Enabled := False;
end;

// IO
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ChangF then
    if application.MessageBox('ύXĂ܂ۑI܂ ?','', MB_YESNO) = idNo then
                  CanClose := false;
end;

//------------
// I
//------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if FFileoutStream <> nil then FreeAndNil(FFileoutStream);
  if LGPImage <> nil then FreeAndNil(LGPImage);
  if LGPImageDisp <> nil then FreeAndNil(LGPImageDisp);
  if Twain <> nil then FreeAndNil(Twain);
  if FFileinpStream <> nil then FreeAndNil(FFileinpStream);
end;

end.
